#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_line(const vector<int>& line, int m) 
{
    for (int i = 0; i < (int)line.size(); i++)
    {
        if (line[i] == 1)
            cout << "+";
        else 
            cout << "-";
    }
    for (int i = line.size(); i < m; i++)
        cout << ".";
    cout << endl;
}

void write_test(vector<vector<int>> test, int m) 
{
    cout << test.size() << ' ' << m << endl;
    for (int i = 0; i < (int)test.size(); i++)
        write_line(test[i], m);
}

void gen_rand(int n, int m, int cnt)
{
    int k = rnd.next(n / 2, n);
    vector<vector<int>> test(n);
    while (cnt--)
    {
        int i = rnd.next(k);
        if ((int)test[i].size() < m)
            test[i].push_back(rnd.next(2));
    }
    shuffle(test.begin(), test.end());
    write_test(test, m);
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int cnt = atoi(argv[3]);
    if (argc > 3 && atoi(argv[4]) == 1)
    {    
        n = rnd.next(n / 2, n);
        m = rnd.next(m / 2, m);
    }
    gen_rand(n, m, cnt);
    return 0;
}