import itertools
import random
import sys


def generate():
    yield (9, {3, 4})
    yield (10**3, {x for x in range(10) if x not in (1,)})
    yield (10**5, {x for x in range(10) if x not in (3, 4)})
    yield (1, {2, 3, 4})

    def bads(mem=None):
        if mem is None:
            mem = [[] for _ in range(11)]
            for mask in range(2**10):
                s = set(x for x in range(10) if mask & (1 << x))
                mem[len(s)].append(s)
        size = random.randint(1, 9)
        return random.choice(mem[size])

    for i in range(12):
        yield (random.randint(1, 10**5), bads())

    yield (10**18, bads())

    for i in range(12):
        yield (random.randint(10**6, 10**18), bads())


if __name__ == '__main__':
    random.seed(';'.join(sys.argv))

    for i, (n, bads) in enumerate(generate()):
        fname = '{:02}'.format(i + 1)
        with open(fname, 'w') as f:
            print(n, file=f)
            print(len(bads), file=f)
            print(*sorted(bads), file=f)
