#include <bits/stdc++.h>
using namespace std;


int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  
  uniform_int_distribution<int> distr;
  mt19937 tw(960172);
  
  int const maxn = 1e6 + 100;
  int const inf = 1e9 + 100;

  vector<int> primes;
  vector<char> sieve(maxn, 1);
  sieve[0] = sieve[1] = 0;
  for (int i = 2; i < maxn; ++i) {
    if (sieve[i]) {
      for (int j = i + i; j < maxn; j += i) {
        sieve[j] = 0;
      }
      if (i % 4 == 1) {
        primes.push_back(i);
      }
    }
  }
  cerr << "There are " << primes.size() << " primes\n";
  
  vector<int> ans(maxn, inf);
  for (int i = 1; i < maxn; i += 2) {
    ans[i] = 2;
  }
  for (int p : primes) {
    int root = -1;
    while (true) {
      int x = distr(tw) % (p - 3) + 2;
      int xpow = 1;
      for (int b = (p - 1) / 4; b; b /= 2) {
        if (b % 2 == 1) {
          xpow = (long long) xpow * x % p;
        }
        x = (long long) x * x % p;
      }
      if (xpow != 1 && xpow != p - 1) {
        root = xpow;
        break;
      }
    }
    for (int d : {root, p - root}) {
      for (int x = d; x < maxn; x += p) {
        ans[x] = min(ans[x], p);
      }
    }
  }
  
  int q;
  cin >> q;
  for (int i = 0; i < q; ++i) {
    int n;
    cin >> n;
    long long n2 = (long long) n * n + 1;
    // cerr << n << ", " << n2 << ": " << ans[n] << '\n';
    if (ans[n] == inf || ans[n] == n2) {
      cout << -1 << '\n';
    } else {
      cout << ans[n] << ' ' << n2 / ans[n] << '\n';
    }
  }
}
