#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include "testlib.h"

using namespace std;

int checkAnswer(InStream& stream, const std::string &name, const std::vector<int> &x, const std::vector<int> &y) {
    int n = x.size();
    std::vector<int> p(n);
    std::vector<int> used(n, false);
    p[0] = stream.readInt();
    if (p[0] == -1) {
        return -1;
    }
    if (0 >= p[0] || p[0] > n) {
        stream.quitf(_wa, "%s[1] is not in [1, %d]", name, n);
    }
    used[p[0] - 1] = true;
    for (int i = 1; i < n; i++) {
        p[i] = stream.readInt();
        if (0 >= p[i] || p[i] > n) {
            stream.quitf(_wa, "%s[%d] is not in [1, %d]", name, i + 1, n);
        }
        if (used[p[i] - 1]) {
            stream.quitf(_wa, "Killing already killed drone #%d on iteration #%d", p[i], i + 1);
        }
        used[p[i] - 1] = true;
        if (std::max(std::abs(x[p[i] - 1]), std::abs(y[p[i] - 1])) <= i) {
            stream.quitf(_wa, "Drone #%d has reached (0, 0) before it was killed", p[i]);
        }
    }
    return 1;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    
    std::vector<int> x(n), y(n);
    for (int i = 0; i < n; i++) {
        x[i] = inf.readInt();
        y[i] = inf.readInt();
    }

    int j = checkAnswer(ans, "jans", x, y);
    int p = checkAnswer(ouf, "pans", x, y);
    if (j == -1 && p != -1) {
        quitf(_fail, "participant found solution when jury didn't");
    }
    if (j != -1 && p == -1) {
        quitf(_wa, "participant didn't find solution but jury did");
    }
    if (j == -1) {
        quitf(_ok, "ok, no answer");
    } else {
        quitf(_ok, "ok, correct removal");
    }
    return 0;
}
