import random
import math
random.seed("basic03/drones")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([[0, 1], [-2, 3], [2, 2]])
        self.print_test([[0, 1], [-2, 2], [2, 2]])

    def generate_min_tests(self):
        self.print_test([[0, 1]])
        self.print_test([[-10**5, -10**5]])
        self.print_test([[1, 1], [-1, -1]])
        self.print_test([[1, 1], [-1, -2]])
        self.print_test([[2, 2], [-2, -2]])
        self.print_test([[2, 2], [-2, -2], [2, -2], [10**5, 10**5], [-10**5, -10**5]])
        self.print_test([[2, 2], [2, 2]])
        self.print_test([[1, 2], [-1, 2], [0, -2]])
        self.print_test([[1, 2], [-1, 2], [0, -3]])
        self.print_test([[1, 2], [-1, 2], [0, -3], [0, 5], [0, 4]])
        self.print_test([[1, 2], [4, 0], [-1, 2], [0, -3], [0, 4]])

    def generate_hand_tests(self):
        pass

    def generate_random_test(self, n, maxc):
        m = random.randint(1, max(1, n // 5))
        drones = []
        for i in range(m):
            t = random.randint(0, 3)
            if t == 0:
                x = maxc
                y = random.randint(-maxc, maxc)
            elif t == 1:
                x = -maxc
                y = random.randint(-maxc, maxc)
            elif t == 2:
                x = random.randint(-maxc, maxc)
                y = maxc
            else:
                x = random.randint(-maxc, maxc)
                y = -maxc
            drones.append([x, y])
        for i in range(n - m):
            x = random.randint(-maxc + 1, maxc - 1)
            y = random.randint(-maxc + 1, maxc - 1)
            while x == 0 and y == 0:
                x = random.randint(-maxc + 1, maxc - 1)
                y = random.randint(-maxc + 1, maxc - 1)
            drones.append([x, y])
        self.print_test(drones)

    def generate_max_tests(self, maxn):
        drones = [[maxn, maxn] for _ in range(maxn)]
        self.print_test(drones)
        drones = [[-maxn, -maxn] for _ in range(maxn)]
        self.print_test(drones)
        drones = [[-maxn, maxn] for _ in range(maxn)]
        self.print_test(drones)
        drones = [[maxn, -maxn] for _ in range(maxn)]
        self.print_test(drones)
        drones = [[maxn, 0] for _ in range(maxn)]
        self.print_test(drones)
        drones = [[-maxn, 0] for _ in range(maxn)]
        self.print_test(drones)
        drones = [[0, -maxn] for _ in range(maxn)]
        self.print_test(drones)
        drones = [[0, maxn] for _ in range(maxn)]
        self.print_test(drones)

        drones = [[-maxn + i, -maxn + i] for i in range(maxn)]
        self.print_test(drones)
        a = [-1, 1]
        drones = [[a[random.randint(0, 1)] * (-maxn + i), a[random.randint(0, 1)] * (-maxn + i)] for i in range(maxn)]
        self.print_test(drones)

    def print_test(self, drones):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)
        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(len(drones), file=test_file)
        print('\n'.join(map(lambda e: ' '.join(map(str, e)), drones)), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()

        for n in [3, 5, 10, 50, 100, 1000, 10**4, 10**5]:
            cs = list(filter(lambda n: n >= 3, set([n // 3, n // 2, 2 * n // 3, 3 * n // 4, n])))
            for maxc in cs:
                self.generate_random_test(n, maxc)
        self.generate_max_tests(10**5)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
