#include <bits/stdc++.h>

struct Drone {
    int x;
    int y;
    int id;

    Drone() {}
    Drone(int x, int y, int id): x(x), y(y), id(id) {}

    int distance() const {
        return std::max(std::abs(x), std::abs(y));
    }

    bool operator < (const Drone &other) const {
        int d1 = distance();
        int d2 = other.distance();
        return d1 < d2 || (d1 == d2 && id < other.id);
    }
};

int main() {
    int n;
    scanf("%d", &n);
    std::set<Drone> drones;
    for (int i = 0; i < n; i++) {
        int x, y;
        scanf("%d%d", &x, &y);
        drones.insert(Drone(x, y, i));
    }
    std::vector<int> answer(n);
    int diff = 0;
    for (int i = 0; i < n; i++) {
        Drone d = *drones.begin();
        drones.erase(drones.begin());
        if (d.distance() - diff <= 0) {
            puts("-1");
            return 0;
        }
        answer[i] = d.id;
        diff++;
    }
    for (int i = 0; i < n; i++) {
        printf("%d%c", answer[i] + 1, " \n"[i == n - 1]);
    }
    return 0;
}
