#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>

using namespace std;

int solve();

#define ss second
#define ff first
#define y1 y111
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)((x).size()))
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> ipair;
typedef pair <ll, ll > lpair;

const int MAXN = (int)300 + 7, IINF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 7, MOD = (ll)1e9;
const double INFfl = (double)1e18 + 7, EPS = (double)1e-8, PI = atan2(0, -1);
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen ("input.txt", "r", stdin);
	freopen ("output.txt", "w", stdout);
#else
	cin.tie(0);
	cout.tie(0);
	#ifdef TASK
		freopen (TASK".in", "r", stdin);
		freopen (TASK".out", "w", stdout);
	#endif
#endif
	solve();
	return 0;
}

int n, m;
bool a[MAXN][MAXN];
bool used[MAXN][MAXN];

bool can_go (ipair c, ipair b, bool f) {
	if (f) {
		if (b.ff < 1 || b.ff > n)
			return 0;
		for (int i = min(c.ff, b.ff); i <= max(c.ff, b.ff); ++i) {
			if (a[i][c.ss]) return 0;
		}
	} else {
		if (b.ss < 1 || b.ss > m)
			return 0;
		for (int i = min(c.ss, b.ss); i <= max(c.ss, b.ss); ++i) {
			if (a[c.ff][i]) return 0;
		}
	}
	return 1;
}

bool is(int x, int y) {
	return (!used[x][y] && x > 0 && x <= n && y > 0 && y <= m);
}

bool dfs(int x, int y) {
	used[x][y] = 1;
	if (y == m) return 1;
	for (int i = 0; i < 4; ++i) {
		ipair e = {x + DX[i], y + DY[i]};
		if (is(e.ff, e.ss)) 
			if (dfs(e.ff, e.ss))
				return 1;
	}
	return 0;
}

bool check (int l) {
	memset(used, 0, sizeof(used));
	if (l == 0) return 1;
	if (l == 1) {
		for (int i = 1; i <= n; ++i) {
			if (!used[i][1] && !a[i][1] && dfs(i, 1))
				return 1;
		}
		return 0;
	}
	queue <pair <int, int>> q;
	for (int i = 1; i <= n; i++) {
		if (can_go({i, 1}, {i + l - 1, 1}, 1)) {
			if (!used[i][1]) q.push({i, 1});
			used[i][1] = 1;
			if (!used[i + l - 1][1]) q.push({i + l - 1, 1});
			used[i + l - 1][1] = 1;
		}
	}

	while (q.size()) {
		ipair cur = q.front();
		q.pop();
		if (can_go(cur, {cur.ff + l - 1, cur.ss}, 1)) {
			int it = cur.ff + l - 1;
			while (it >= l && !a[it - l + 1][cur.ss]) it--;
			it++;
			while (it <= n && !a[it][cur.ss]) {
				if (!used[it][cur.ss]) {
					q.push({it, cur.ss});
					used[it][cur.ss] = 1;
				}
				if (!used[it - l + 1][cur.ss]) {
					q.push({it - l + 1, cur.ss});
					used[it - l + 1][cur.ss] = 1;
				}
				it++;
			} 
		} 

		if (can_go(cur, {cur.ff - l + 1, cur.ss}, 1)) {
			int it = cur.ff - l + 1;
			while (it <= n - l + 1 && !a[it + l - 1][cur.ss]) it++;
			it--;
			while (it > 0 && !a[it][cur.ss]) {
				if (!used[it][cur.ss]) {
					q.push({it, cur.ss});
					used[it][cur.ss] = 1;
				}
				if (!used[it + l - 1][cur.ss]) {
					q.push({it + l - 1, cur.ss});
					used[it + l - 1][cur.ss] = 1;
				}
				it--;
			} 
		} 

		if (can_go(cur, {cur.ff, cur.ss + l - 1}, 0)) {
			int it = cur.ss + l - 1;
			while (it >= l && !a[cur.ff][it - l + 1]) it--;
			it++;
			while (it <= m && !a[cur.ff][it]) {
				if (!used[cur.ff][it]) {
					q.push({cur.ff, it});
					used[cur.ff][it] = 1;
				}
				if (!used[cur.ff][it - l + 1]) {
					q.push({cur.ff, it - l + 1});
					used[cur.ff][it - l + 1] = 1;
				}
				it++;
			} 
		} 

		if (can_go(cur, {cur.ff, cur.ss - l + 1}, 0)) {
			int it = cur.ss - l + 1;
			while (it <= m - l + 1 && !a[cur.ff][it + l - 1]) it++;
			it--;
			while (it > 0 && !a[cur.ff][it]) {
				if (!used[cur.ff][it]) {
					q.push({cur.ff, it});
					used[cur.ff][it] = 1;
				}
				if (!used[cur.ff][it + l - 1]) {
					q.push({cur.ff, it + l - 1});
					used[cur.ff][it + l - 1] = 1;
				}
				it--;
			} 
		} 
	}
	
	
	for (int i = 1; i <= n - l + 1; ++i)
		if (used[i][m] && can_go({i, m}, {i + l - 1, m}, 1)) {
			return 1;
		}
	return 0;
}

int solve() {
	cin >> n >> m;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			char c;
			cin >> c;
			a[i][j] = (c == '.' ? 0 : 1);
		}
	}

	int l = 0, r = max(n, m) + 1;

	while (r - l > 1) {
		int m = (r + l) / 2;
		if (check(m)) {
			l = m;
		} else {
			r = m;
		}
	}

	cout << l;
	return 0;
}