#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

void print(const pair<int, pair<int, int>>& s) {
    cerr << s.first << " " << s.second.first << " " << s.second.second << endl;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    set<pair<int, pair<int, int>>> p;
    vector<int> b(n), g(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        p.insert({b[i], {0, i}});
    }
    for (int i = 0; i < n; i++) {
        cin >> g[i];
        p.insert({g[i], {1, i}});
    }

    set<pair<int, pair<int, int>>> segs;
    auto it = p.begin();
    auto it1 = it;
    ++it1;
    for (; it1 != p.end(); ++it, ++it1) {
        if (it1->second.first != it->second.first) {
            int dst = it1->first - it->first;
            segs.insert({dst, it->second});
        }
    }

    vector<pair<int, int>> ans;

    while (!segs.empty()) {
        auto seg = *segs.begin();
        segs.erase(segs.begin());

        pair<int, pair<int, int>> f, s;
        if (seg.second.first == 0) {
            f = {b[seg.second.second], seg.second};
        } else {
            f = {g[seg.second.second], seg.second};
        }
        s = *p.upper_bound(f);

        if (f.second.first == 0) {
            ans.emplace_back(f.second.second, s.second.second);
        } else {
            ans.emplace_back(s.second.second, f.second.second);
        }

        auto it_prev = p.find(f);
        bool has_prev = true;
        if (it_prev == p.begin()) {
            has_prev = false;
        } else {
            --it_prev;
        }

        auto it_next = p.find(s);
        bool has_next = true;
        ++it_next;
        if (it_next == p.end()) {
            has_next = false;
        }

        if (has_prev && it_prev->second.first != f.second.first) {
            int dst = f.first - it_prev->first;
            segs.erase({dst, it_prev->second});
        }

        if (has_next && it_next->second.first != s.second.first) {
            int dst = it_next->first - s.first;
            segs.erase({dst, s.second});
        }

        if (has_prev && has_next && it_prev->second.first != it_next->second.first) {
            int dst = it_next->first - it_prev->first;
            segs.insert({dst, it_prev->second});
        }

        p.erase(f);
        p.erase(s);
    }

    for (auto& pr : ans) {
        cout << pr.first + 1 << " " << pr.second + 1 << "\n";
    }

    return 0;
}
