#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> b(n), g(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> g[i];
    }

    vector<pair<int, int>> bs(n), gs(n);
    for (int i = 0; i < n; i++) {
        bs[i] = {b[i], i};
        gs[i] = {g[i], i};
    }
    sort(bs.begin(), bs.end());
    sort(gs.begin(), gs.end());

    vector<int> lt(n), rt(n);
    for (int i = 0; i < n; i++) {
        int L = -1;
        int R = n;
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (gs[M].first <= bs[i].first) {
                L = M;
            } else {
                R = M;
            }
        }
        lt[i] = L;
        rt[i] = R;
    }

    vector<int> mt(n, -1);
    deque<int> boys;
    for (int i = 0; i < n; i++) {
        boys.push_back(i);
    }
    while (!boys.empty()) {
        int bi = boys.front();
        boys.pop_front();

        int gi = -1;
        if (lt[bi] != -1) {
            gi = lt[bi];
        }
        if (rt[bi] != n && (gi == -1 || abs(bs[bi].first - gs[gi].first) > abs(bs[bi].first - gs[rt[bi]].first))) {
            gi = rt[bi];
        }

        if (gi == lt[bi]) {
            lt[bi]--;
        } else {
            rt[bi]++;
        }

        if (mt[gi] == -1) {
            mt[gi] = bi;
        } else if (abs(gs[gi].first - bs[mt[gi]].first) > abs(gs[gi].first - bs[bi].first)) {
            boys.push_back(mt[gi]);
            mt[gi] = bi;
        } else {
            boys.push_back(bi);
        }
    }

    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        ans.emplace_back(bs[mt[i]].second, gs[i].second);
    }
    for (auto p : ans) {
        cout << p.first + 1 << " " << p.second + 1 << "\n";
    }

    return 0;
}
