#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;
typedef unsigned long long my_hash;

const int dd = (int)1e5 + 7;
const int LOG = 18;

int up[dd][LOG];
my_hash h[dd][LOG];

const int P = 31;

int power[LOG];
int dist[dd];

struct st { 
	int v;
	bool operator < (st ob) const {
		int a = v, b = ob.v;
		for (int i = LOG - 1; i >= 0; i--) {
			if (h[a][i] == h[b][i]) {
				a = up[a][i];
				b = up[b][i];
			}
		}		
		return make_pair( h[a][0], v ) < make_pair( h[b][0], ob.v );
	}
};

set<st> S;
set<st>::iterator pos[dd];

my_hash merge(my_hash a, my_hash b, int lg) {
	return a + b * power[lg];
}

int lcp(st q, st w) {
	int a = q.v, b = w.v;
	for (int i = LOG - 1; i >= 0; i--) {
		if (h[a][i] == h[b][i]) {
			a = up[a][i];
			b = up[b][i];
		}
	}
	return dist[q.v] - dist[a];
}

int recalc(set<st>::iterator it) {
	if (it == S.begin()) return dist[it->v] - (it == --S.end() ? 0 : lcp(*it, *next(it)));
	if (it == --S.end()) return dist[it->v] - lcp(*prev(it), *it);
	
	return dist[it->v] - lcp(*prev(it), *it) - lcp(*it, *next(it)) + lcp(*prev(it), *next(it));
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int q; cin >> q;
	
	int root = 0, nv = 1;
	for (int i = 0; i < LOG; i++) {
		h[root][i] = 0;
		up[root][i] = root;
	}
	
	power[0] = P;
	for (int i = 1; i < LOG; i++) {
		power[i] = power[i - 1] * power[i - 1];
	}
	
	ll cur = 0;
	while (q--) {
		int tp; cin >> tp;
		if (tp == 1) {
			int p; char c; 
			cin >> p >> c;
			p--;
			
			int v = nv++;
			
			dist[v] = dist[p] + 1;
			up[v][0] = p, h[v][0] = c - 'a' + 1;
			
			for (int i = 1; i < LOG; i++) {
				up[v][i] = up[up[v][i - 1]][i - 1];
				h[v][i] = merge(h[v][i - 1], h[up[v][i - 1]][i - 1], i - 1);
			}
			pos[v] = S.insert({ v }).first;
			cur += recalc(pos[v]);
		} else {
			int v; cin >> v;
			v--;
			cur -= recalc(pos[v]);
			S.erase(pos[v]);
		}
		cout << cur << "\n";
	}
	return 0;
}