#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

#define TASK ""
typedef long long ll;
const int INF = (int)1e9 + 23;
const ll LINF = (ll)1e18 + 23;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else 
	cin.tie(0);
	cout.tie(0);
	if (TASK != "") freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	solve();
	return 0;
}

ll ans = 0;
vector<int> Z(string s, bool need) {
	int n = (int)s.size();
	vector<int> z(n);
	for (int i = 1, l = 0, r = 0; i < n; ++i) {
		if (i <= r)	z[i] = min(r - i + 1, z[i - l]);
		while (i + z[i] < n && s[z[i]] == s[i + z[i]]) z[i]++;
		if (i + z[i] - 1 > r)
			l = i,
			r = i + z[i] - 1;
		if (need && i + z[i] == n && i < z[i] && i * 2 != z[i]) ans--;
	
	}
	return z;
}

int solve() {

	string s; cin >> s;
	int n = s.size();

	ans = (n - 1ll) * (n - 2) / 2;
	vector<int> z = Z(s, 1);
	
	reverse(s.begin(), s.end());
	vector<int> zr = Z(s, 0);
	
	for (int i = 2; i < n; i += 2) {
		if (i / 2 <= z[i / 2]) ans--;
		if (i / 2 <= zr[i / 2] && i / 2 * 3 != n) ans--;
	}

	cout << ans;
	
	return 0;
}