#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

#define TASK ""
typedef long long ll;
const int INF = (int)1e9 + 23;
const ll LINF = (ll)1e18 + 23;
const int MAXN = 500015;
const ll P = 239017;
const ll MOD = 1e9 + 7;
const ll MOD1 = 1e9 + 9;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else 
	cin.tie(0);
	cout.tie(0);
	if (TASK != "") freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	solve();
	return 0;
}

ll h[MAXN], h1[MAXN], p[MAXN], p1[MAXN];
void build_hash(string &s){
	for (int i = 0; i < (int)s.size(); i++) {
		if (!i) h[i] = s[i], h1[i] = s[i];
		else {
			h[i] = (h[i - 1] * P + s[i]) % MOD;
			h1[i] = (h1[i - 1] * P + s[i]) % MOD1;
		}
	}
}

pair<int, int> get_hash(int l, int r) {
	int c = (p[r - l + 1] * h[l - 1]) % MOD;
	if (l == 0) c = 0;

	int c1 = (p1[r - l + 1] * h1[l - 1]) % MOD1;
	return { 
		(MOD + h[r] - c) % MOD,
		(MOD1 + h1[r] - c1) % MOD1 
	};
}
int solve() {

	string s; cin >> s;
	int n = s.size();
	
	build_hash(s);
	p[0] = 1, p1[0] = 1;
	for (int i = 1; i < n + 5; i++) {
		p[i] = (p[i - 1] * P) % MOD;
		p1[i] = (p1[i - 1] * P) % MOD1;
	}

	ll ans = 0;
	for (int i = 1; i < n; i++) {
		for (int j = 1; j + i < n; j++) {
			auto a = get_hash(0, i - 1);
			auto b = get_hash(i, i + j - 1);
			auto c = get_hash(i + j, n - 1);
			
			auto ab = get_hash(0, i + j - 1);
			auto bc = get_hash(i, n - 1);
			if (a == b) continue;
			if (b == c) continue;
			if (ab == bc) continue; 
			ans++;
		}
	}
	
	cout << ans;
	return 0;
}