#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>

using namespace std;

typedef long long ll;

#ifdef ONPC
    mt19937 rnd(228);
#else
    mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const int M = 998244353;
const int P = (M + 1) / 2;

inline int add(int a, int b)
{
    a += b;
    if (a < 0) a += M;
    if (a >= M) a -= M;
    return a;
}

inline int mul(int a, int b)
{
    return (a * (ll) b) % M;
}

const int N = 2e5 + 6;

vector <int> g[N];

void dfs(int v, int pr)
{
    for (int to : g[v])
    {
        if (to != pr)
        {
            dfs(to, v);
        }
    }
}

set <int> q;
vector <int> a;

void zhfs(int v, int pr, int need)
{
    a.push_back(v);
    if (v == need)
    {
        for (int x : a)
        {
            q.insert(x);
        }
    }
    for (int to : g[v])
    {
        if (to != pr)
        {
            zhfs(to, v, need);
        }
    }
    a.pop_back();
}

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector <int> p(n, -1);
    for (int i = 1; i < n; i++)
    {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
        g[i].push_back(p[i]);
        int lim = (1 << (i + 1));
        int sum = 0;
        for (int mask = 0; mask < lim; mask++)
        {
            vector <int> a;
            for (int j = 0; j <= i; j++)
            {
                if ((mask >> j) & 1)
                {
                    a.push_back(j);
                }
            }
            q.clear();
            for (int x : a)
            {
                for (int y : a)
                {
                    if (x <= y)
                    {
                        zhfs(x, -1, y);
                    }
                }
            }
            sum += (int) q.size();
        }
        cout << sum << ' ';
    }
    cout << '\n';
}
