#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include "testlib.h"

using namespace std;

const int MAXANS = (int)1e3;
const int INF = (int)1e6 + 3;
const int MAXN = (int)1e3;

int x, y;
int N;
int checkAns(InStream& stream) {
	int n = stream.readInt(-1, MAXANS, "answer");
	N = n;
	vector<long long> v;
	v.push_back(0);
	v.push_back(x), v.push_back(y);
	for (int i = 0; i < n; i++) {
		int t = stream.readInt(1, 4, "type");
		if (t <= 2) {
			int a = stream.readInt(1, v.size() - 1, "first cell");
			int b = stream.readInt(1, v.size() - 1, "second cell");

			if (t == 1) {
				if (v[a] + v[b] >= (1ll << 31)) 
					quitf(_wa, "participant's number is too big");
				v.push_back(v[a] + v[b]);
			} else {
				if (v[a] - v[b] < 0)
					quitf(_wa, "participant's number less then zero");
				v.push_back(v[a] - v[b]);
			}
		} else {
			int a = stream.readInt(1, v.size() - 1, "cell");
			if (t == 3) {
				if (v[a] * 2 >= (1ll << 31)) {
					quitf(_wa, "participant's number is too big");
				}
				v.push_back(v[a] * 2);
			} else v.push_back(v[a] / 2);
		}
	}
	if (v.back() == (x ^ y)) return 1;
	return -1;
}

int main(int argc, char *argv[]) {
	registerTestlibCmd(argc, argv);

	x = inf.readInt();
	y = inf.readInt();
	

//	cout << "!";
	int j = checkAns(ans), p = checkAns(ouf);
	if (j == -1) quitf(_fail, "jury doesn't have correct solution");
	if (p == -1) quitf(_wa, "participant doesn't have correct solution");
	quitf(_ok, "%d lines", N);
	return 0;
}